#*****************************************************************************
#                                                                            *
# Make file for VMS                                                          *
# Author : J.Jansen (joukj@hrem.nano.tudelft.nl)                             *
# Date : 13 February 2008                                                    *
#                                                                            *
#*****************************************************************************

CFLAGS=/name=(as_is,short)/float=ieee

SUF=obj

ASSRCS=	sh.c sh.dir.c sh.dol.c sh.err.c sh.exec.c sh.char.c \
	sh.exp.c sh.file.c sh.func.c sh.glob.c sh.hist.c sh.init.c \
	sh.lex.c sh.misc.c sh.parse.c sh.print.c sh.proc.c sh.sem.c \
	sh.set.c sh.time.c sh.char.h sh.dir.h sh.proc.h sh.h \
	tw.color.c
PSSRCS= sh.decls.h glob.c glob.h mi.termios.c mi.wait.h mi.varargs.h ma.setp.c \
	vms.termcap.c tc.nls.h
SHSRCS= $(ASSRCS) $(PSSRCS)
SHOBJS=	sh.$(SUF),sh.dir.$(SUF),sh.dol.$(SUF),sh.err.$(SUF),sh.exec.$(SUF),\
	sh.char.$(SUF),sh.exp.$(SUF),sh.file.$(SUF),sh.func.$(SUF),\
	sh.glob.$(SUF),sh.hist.$(SUF),sh.init.$(SUF),sh.lex.$(SUF),\
	sh.misc.$(SUF),sh.parse.$(SUF),sh.print.$(SUF),sh.proc.$(SUF),\
	sh.sem.$(SUF),sh.set.$(SUF),sh.time.$(SUF),glob.$(SUF),\
	mi.termios.$(SUF),ma.setp.$(SUF),vms.termcap.$(SUF)

TWSRCS= tw.decls.h tw.h tw.help.c tw.init.c tw.parse.c tw.spell.c \
	tw.comp.c tw.color.c
TWOBJS=	tw.help.$(SUF),tw.init.$(SUF),tw.parse.$(SUF),tw.spell.$(SUF),\
	tw.comp.$(SUF),tw.color.$(SUF)

EDSRCS= ed.chared.c ed.decls.h ed.defns.c ed.h ed.init.c ed.inputl.c \
	ed.refresh.c ed.screen.c ed.xmap.c ed.term.c ed.term.h
EDOBJS=	ed.chared.$(SUF),ed.refresh.$(SUF),ed.screen.$(SUF),ed.init.$(SUF),\
	ed.inputl.$(SUF),ed.defns.$(SUF),ed.xmap.$(SUF),ed.term.$(SUF)

TCSRCS= tc.alloc.c tc.bind.c tc.const.c tc.decls.h tc.disc.c \
	tc.func.c tc.os.c tc.os.h tc.printf.c tc.prompt.c \
	tc.sched.c tc.sig.c tc.sig.h tc.str.c sh.types.h tc.vers.c tc.wait.h \
	tc.who.c tc.h tc.nls.c
TCOBJS=	tc.alloc.$(SUF),tc.bind.$(SUF),tc.const.$(SUF),tc.defs.$(SUF),\
	tc.disc.$(SUF),tc.func.$(SUF),tc.os.$(SUF),tc.printf.$(SUF),\
	tc.prompt.$(SUF),tc.sched.$(SUF),tc.sig.$(SUF),tc.str.$(SUF),\
	tc.vers.$(SUF),tc.who.$(SUF),tc.nls.$(SUF)

PVSRCS= Makefile.std Makefile.vms Makefile.in Makefile.win32
AVSRCS= Fixes MAKEDIFFS MAKESHAR NewThings README FAQ \
	WishList config_f.h eight-bit.me glob.3 patchlevel.h \
	pathnames.h tcsh.man Ported src.desc Imakefile imake.config \
	README.imake complete.tcsh vmsreadme.txt termcap.vms snames.h \
	host.defs gethost.c tcsh.man2html configure.in configure config.h.in

VHSRCS=$(PVSRCS) $(AVSRCS)

CONFSRCS=config/* 

ALLSRCS=  $(SHSRCS) $(TWSRCS) $(EDSRCS) $(TCSRCS) $(VHSRCS)
DISTSRCS= $(PSSRCS) $(TWSRCS) $(EDSRCS) $(TCSRCS) $(AVSRCS)


OBJS= $(SHOBJS),$(TWOBJS),$(EDOBJS),$(TCOBJS)

all : tcsh.exe
	@ write sys$output "all done"

tcsh.exe : $(OBJS)
	link/exec=tcsh.exe $(OBJS)

config.h : config.h_vms
	copy config.h_vms config.h

config_p.h : config_p.h_vms
	copy config_p.h_vms config_p.h

$(OBJS) : config.h config_p.h

sh.obj : sh.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h tc.nls.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
sh.dir.obj : sh.dir.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
sh.dol.obj : sh.dol.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
sh.err.obj : sh.err.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
sh.exec.obj : sh.exec.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS)/nowarn $(MMS$TARGET_NAME).c
sh.char.obj : sh.char.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
sh.exp.obj : sh.exp.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
sh.file.obj : sh.file.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
sh.func.obj : sh.func.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS)/nowarn $(MMS$TARGET_NAME).c
sh.glob.obj : sh.glob.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
sh.hist.obj : sh.hist.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
sh.init.obj : sh.init.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
sh.lex.obj : sh.lex.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
sh.misc.obj : sh.misc.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
sh.parse.obj : sh.parse.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
sh.print.obj : sh.print.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
sh.proc.obj : sh.proc.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
sh.sem.obj : sh.sem.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
sh.set.obj : sh.set.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
sh.time.obj : sh.time.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
glob.obj : glob.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
mi.termios.obj : mi.termios.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
ma.setp.obj : ma.setp.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
vms.termcap.obj : vms.termcap.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tw.help.obj : tw.help.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tw.init.obj : tw.init.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tw.parse.obj : tw.parse.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tw.spell.obj : tw.spell.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tw.comp.obj : tw.comp.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tw.color.obj : tw.color.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
ed.chared.obj : ed.chared.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h ed.defns.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
ed.refresh.obj : ed.refresh.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h ed.defns.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
ed.screen.obj : ed.screen.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h ed.defns.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
ed.init.obj : ed.init.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h ed.defns.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
ed.inputl.obj : ed.inputl.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h ed.defns.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
ed.defns.obj : ed.defns.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h ed.defns.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
ed.xmap.obj : ed.xmap.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h ed.defns.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
ed.term.obj : ed.term.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h ed.defns.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tc.alloc.obj : tc.alloc.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tc.bind.obj : tc.bind.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tc.const.obj : tc.const.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tc.defs.obj : tc.defs.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tc.disc.obj : tc.disc.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tc.func.obj : tc.func.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tc.os.obj : tc.os.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tc.printf.obj : tc.printf.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tc.prompt.obj : tc.prompt.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tc.sched.obj : tc.sched.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tc.sig.obj : tc.sig.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tc.str.obj : tc.str.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tc.vers.obj : tc.vers.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tc.who.obj : tc.who.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c
tc.nls.obj : tc.nls.c config.h sh.h sh.err.h tc.h tc.const.h tc.os.h
	cc $(CFLAGS) $(MMS$TARGET_NAME).c

ed.defns.h : ed.defns.c
	@ write sys$output "creating ed.defns.h ..."
	@ set file/enter=tmp__.c ed.defns.c
	@ open/write of tmp.txt1
	@ write of "/* Do not edit this file, make creates it. */"
	@ write of "#ifndef _h_ed_defns"
	@ write of "#define _h_ed_defns"
	@ close of
	@ write sys$output "... grep ....."
	@ pipe grep "[FV]_" tmp__.c | grep "^#define" sys$input > tmp.txt2
	@ open/write of tmp.txt3
	@ write of "#endif /* _h_ed_defns */"
	@ close of
	@ write sys$output "... copying ....."
	@ copy tmp.txt1,tmp.txt2,tmp.txt3 ed.defns.h
	@ set file/remove tmp__.c;*
	@ delete tmp.txt*;*
	@ write sys$output "... ed.defns.h created"

sh.err.h : sh.err.c
	@ write sys$output "creating sh.err.h ..."
	@ set file/enter=tmp__.c sh.err.c
	@ open/write of tmp.txt1
	@ write of "/* Do not edit this file, make creates it. */"
	@ write of "#ifndef _h_sh_err"
	@ write of "#define _h_sh_err"
	@ close of
	@ write sys$output "... grep ....."
	@ pipe grep "ERR_" tmp__.c | grep "^#define" sys$input > tmp.txt2
	@ open/write of tmp.txt3
	@ write of "#endif /* _h_sh_err */"
	@ close of
	@ write sys$output "... copying ....."
	@ copy tmp.txt1,tmp.txt2,tmp.txt3 sh.err.h
	@ set file/remove tmp__.c;*
	@ delete tmp.txt*;*
	@ write sys$output "... sh.err.h created"

tc.const.h : tc.const.c sh.char.h config.h config_f.h sh.types.h sh.err.h
	@ write sys$output "creating rc.const.h ..."
	@ open/write of tmp.txt1
	@ set file/enter=tmp__.c tc.const.c
	@ write of "/* Do not edit this file, make creates it. */"
	@ write of "#ifndef _h_tc_const"
	@ write of "#define _h_tc_const"
	@ close of
	@ write sys$output "... preprocessing ....."
	@ cc/prep=tmp___.c/define=("_h_tc_const") tmp__.c
	@ write sys$output "... grep ..."
	@ pipe grep "Char STR" tmp___.c > gg1.tmp
	@ write sys$output "... sed ..."
	@ pipe gsed -e "s/Char \([a-zA-Z0-9_]*\) *\[ *\].*/extern Char \1[];/"\
		gg1.tmp > gg2.tmp
	@ write sys$output "... sort ..."
	@ sort gg2.tmp tmp.txt2
	@ open/write of tmp.txt3
	@ write of "#endif /* _h_tc_const */"
	@ close of
	@ write sys$output "... copying ....."
	@ copy tmp.txt1,tmp.txt2,tmp.txt3 tc.const.h
	@ set file/remove tmp__.c;*
	@ delete tmp___.c;*
	@ delete tmp.txt*;*
	@ delete gg*.tmp;*
	@ write sys$output "... rc.const.h created"

tc.defs.c : gethost.exe host.defs
	@ write sys$output "creating tc.defs.c ..."
	@ open/write of tmp.txt1
	@ write of "/* Do not edit this file, make creates it. */"
	@ close of
	@ pipe mcr []gethost host.defs > tmp.txt2
	@ copy tmp.txt1,tmp.txt2 tc.defs.c
	@ delete tmp.txt*;*
	@ write sys$output "... tc.defs.c created"

gethost.exe :  gethost.obj
	link/exec=gethost.exe gethost.obj

gethost.obj : gethost.c sh.err.h tc.h tc.const.h tc.os.h sh.h
